UNIT SBplay;

INTERFACE

uses crt, dos;

Procedure SBout(indx: INTEGER);

Procedure SBini;

    CONST
          max=65000;
    TYPE
       ref = ^speech_buffer;
       speech_buffer= RECORD
          item: ARRAY [0..max] OF Shortint;
          END;

    VAR
       sb: BOOLEAN;
       brjc: ARRAY [1..10] OF INTEGER;
       pntr: ARRAY [1..10] OF ref;


IMPLEMENTATION

   CONST
      dmac=1;
      sbadr=$0220;
      resetport = sbadr + $6;
      writeport = sbadr + $C;
      readport  = sbadr + $A;
      pollport  = sbadr + $E;
      rate=8000;
      len=2048;
      bufs=8;

   VAR
   sw: BOOLEAN;
   a,r,pha: longint;
   b: INTEGER;
   f: file;
   datbuff: ref;
   dma1, dma2: array [1..2*len] of byte;
   sammsb,samlsb,adr1msb,adr1lsb,adr2msb,adr2lsb,timec: byte;
   ctr,i,j,kk,samples,adr16,dmapr,sgm,ofset,pag1,pag2: WORD;


    PROCEDURE WriteDSP(bajt: BYTE);

       BEGIN
          i:=0;
          REPEAT
             Inc(i)
             UNTIL (i=MaxInt) OR (Port[WritePort] AND $80 = 0);
          Port[WritePort] := bajt;
          END;

    FUNCTION ReadDSP: BYTE;
       BEGIN
          i:=0;
          REPEAT
             Inc(i)
             UNTIL (i=MaxInt) OR (Port[PollPort] AND $80 <> 0);
          ReadDSP := Port[ReadPort];
          END;

    FUNCTION SBinit: BOOLEAN;
       BEGIN
          Port[resetport]:=1;
          FOR i:= 1 TO 1000 DO;
          Port[resetport]:=0;
          FOR i:= 1 TO 10000 DO;
          sbinit:=ReadDSP=$AA;
          END;

    PROCEDURE PreDMA;
       BEGIN
          sgm:=Seg(dma1[1]);
          ofset:=Ofs(dma1[1]);
          pha:=sgm;
          pha:=16*pha + ofset;
          pag1:=pha DIV 65536;
          adr16:=pha MOD 65536;
          IF NOT (adr16+len<65536) THEN Halt;
          adr1msb:=Hi(adr16);
          adr1lsb:=Lo(adr16);
          sgm:=Seg(dma2[1]);
          ofset:=Ofs(dma2[1]);
          pha:=sgm;
          pha:=16*pha + ofset;
          pag2:=pha DIV 65536;
          adr16:=pha MOD 65536;
          IF NOT (adr16+len<65536) THEN Halt;
          adr2msb:=Hi(adr16);
          adr2lsb:=Lo(adr16);
          CASE dmac OF
             0: dmapr:= $87;
             1: dmapr:= $83;
             2: dmapr:= $81;
             3: dmapr:= $82;
             END;
          timec:= 256 - (1000000 DIV rate);
          samples:=len-1;           { 'ker DMA pusca vsak drugi byte prazen }
          sammsb:= Hi(samples);    {       '-1 zahtevata DMAC in SB }
          samlsb:= Lo(samples);
          WriteDSP($D1);
          sw:=TRUE;
          END;


    PROCEDURE SBoutdma;

       BEGIN
          Port[$A]:=$04 + dmac;    {     'mask DMA channel }
          Port[$C]:=0;             {     'clear msb/lsb ff }
          Port[$B]:=$48 + dmac;    {     'single mode, write }
          IF sw THEN BEGIN
             Port[2 * dmac]:= adr1lsb; {     'buff start adr lsb (&h2=ch1) }
             Port[2 * dmac]:= adr1msb; {     'msb  }
             Port[dmapr]:=pag1;        {     'DMA page register }
             END
          ELSE BEGIN
             Port[2 * dmac]:= adr2lsb; {     'buff start adr lsb (&h2=ch1) }
             Port[2 * dmac]:= adr2msb; {     'msb  }
             Port[dmapr]:=pag2;        {     'DMA page register }
             END;
          Port[1 + 2 * dmac]:= samlsb; { 'no. of samples lsb }
          Port[1 + 2 * dmac]:= sammsb; { 'msb }
          Port[$A]:=dmac;          {     'unmask DMA channel }
          WriteDSP($40);           {     'time constant }
          WriteDSP(timec);         {     '256-1e6/sample_rate }
          WriteDSP($14);           {     'command: DMA DAC   }
          WriteDSP(samlsb);        {     'no. of samples lsb  }
          WriteDSP(sammsb);        {     'msb                }
          END;

  Procedure SBini;
  begin
     PreDMA;
     sb:=FALSE;
     IF SBinit THEN BEGIN
        Assign(f,'F1.SPC');   {$I-}
        Reset(f,1);           {$I+}
        IF IOResult<>0 THEN Writeln('File not found')
        ELSE IF FileSize(f)>65000 THEN Writeln(' File too long')
        ELSE IF FileSize(f)>MaxAvail THEN Writeln(' Not enough memory, ',maxavail)
        ELSE BEGIN
           a:=FileSize(f);
           r:=a MOD 2048;
           IF (r>0) AND ((a+2048-r)<maxavail) THEN a:=a+2048-r;
           GetMem(datbuff,a);
           pntr[1]:=datbuff;
           With datbuff^ do BlockRead(f,item,a,b);
           Writeln('F1 ',b:6,' bytes');
           FOR b:=b TO a DO datbuff^.item[b]:=0;
           brjc[1]:=b;
           Close(f);
           sb:=TRUE;
           END;
        END
     ELSE Writeln(' SB Init failed',#7);
     end;

  Procedure SBout(indx: INTEGER);
  begin
  ctr:=0;
  datbuff:=pntr[indx];
  kk:=brjc[indx];
  repeat
     IF sw THEN
        FOR j:=1 TO len DO dma1[j]:=datbuff^.item[ctr+j]+128
     ELSE
        FOR j:=1 TO len DO dma2[j]:=datbuff^.item[ctr+j]+128;
     WHILE (Port[8] AND 2 = 0) AND (ctr>0) DO;
     SBoutDMA;
     Inc(ctr,len);
     sw:=NOT sw;
     until (ctr>=kk);
   WHILE (Port[8] AND 2 = 0) do;
   WriteDSP($D0);        {Pause 8-bit DMA mode sound I/O          }
   WriteDSP($D3);        {Turn off speaker                        }
   Port[$A]:=$04 + dmac;    {     'mask DMA channel }
   end;

  BEGIN
     END.
